#include <SPI.h>

const int DI[] = {29,28,27,26,25,24,23,22};
#define DI1 29
#define DI2 28 
#define DI3 27
#define DI4 26
#define DI5 25
#define DI6 24
#define DI7 23
#define DI8 22

const int DO[] = {41,40,39,38,37,36,35,34};
#define DO1 41
#define DO2 40 
#define DO3 39
#define DO4 38
#define DO5 37
#define DO6 36
#define DO7 35
#define DO8 34

const int AI[] = {A0,A1,A2,A3,A4,A5,A6,A7};
#define AI1 A0  
#define AI2 A1  
#define AI3 A2  
#define AI4 A3  
#define AI5 A4  
#define AI6 A5  
#define AI7 A6  
#define AI8 A7  

const int AO[] = {2,0,4,6,14,12,10,8};
#define AO2 0  //DACA
#define AO1 2  //DACB
#define AO3 4  //DACC
#define AO4 6  //DACD
#define AO8 8  //DACE
#define AO7 10  //DACF
#define AO6 12  //DACG
#define AO5 14  //DACH

#define DATA 51
#define CLOCK 52
#define LOADD 10
#define DAC dACb

const int dACa = 0,
          dACb = 2,
          dACc = 4,
          dACd = 6,
          dACe = 8,
          dACf = 10,
          dACg = 12,
          dACh = 14,
          dRNG = 1;

#define AIN_Vmax 10

#define LEDY  12
#define LEDR  13

String TxtLetto = "";



void setup() 
{ 
  Serial.begin(9600);
  
  pinMode (LOADD, OUTPUT);
  //Imposta la SPI
  SPI.begin(); 
  SPI.setBitOrder(MSBFIRST);  // Most Significant bit first.
  SPI.setClockDivider(SPI_CLOCK_DIV16);  //16MHz divided by 16 = 1MHz
  SPI.setDataMode(SPI_MODE1);  // zero based clock, data on falling edge, seems like the correct setting
  digitalWrite(LOADD,LOW);
  zeroDACs();
  delay(1000);
  
  pinMode(LEDY, OUTPUT);
  pinMode(LEDR, OUTPUT);

  pinMode(DI1, INPUT);
  pinMode(DI2, INPUT);
  pinMode(DI3, INPUT);
  pinMode(DI4, INPUT);
  pinMode(DI5, INPUT);
  pinMode(DI6, INPUT);
  pinMode(DI7, INPUT);
  pinMode(DI8, INPUT);

  pinMode(DO1, OUTPUT);
  pinMode(DO2, OUTPUT);
  pinMode(DO3, OUTPUT);
  pinMode(DO4, OUTPUT);
  pinMode(DO5, OUTPUT);
  pinMode(DO6, OUTPUT);
  pinMode(DO7, OUTPUT);
  pinMode(DO8, OUTPUT);

  pinMode(AI1, INPUT);
  pinMode(AI2, INPUT);
  pinMode(AI3, INPUT);
  pinMode(AI4, INPUT);
  pinMode(AI5, INPUT);
  pinMode(AI6, INPUT);
  pinMode(AI7, INPUT);
  pinMode(AI8, INPUT);  
 
  for (int i=0; i<3; i=i+1)
  {
    digitalWrite(LEDY, HIGH);    
    digitalWrite(LEDR, HIGH);
    delay(500);
    digitalWrite(LEDY, LOW);    
    digitalWrite(LEDR, LOW);    
    delay(500);
  }
  

  //Imposta la Seriale
  
  while (!Serial) 
  {
    delay(1); // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("System Startup v1.0");
  delay (500);
}



//******************************************************* L O O P *******************************************************
void loop() 
{
  while (Serial.available() > 0) 
  {
    char ChrLetto = Serial.read();
    if ((ChrLetto == '\n') || (ChrLetto == ' ') || (TxtLetto.length()>11)) TxtLetto="";
    else TxtLetto += ChrLetto;
  }

  // print the message and a notice if it's changed:
  if (TxtLetto.charAt(TxtLetto.length()-1) == '#') 
  {
    Serial.print("RX: ");    
    Serial.println(TxtLetto);    
    // if the String's longer than 140 characters, complain:
    if ((TxtLetto.length() >= 7) && (TxtLetto.length() <= 11)) 
    {
      Controlla_Protocollo(TxtLetto);
    } 
    else 
    {
      Serial.println("ERROR");
    }
    TxtLetto = "";
  }
}


//******************************************************* C O N T R O L L A _ P R O T O C O L L O *******************************************************
//Controlla la stringa ricevuta che corrisponda al protocollo ed esegue i comandi impartiti
void Controlla_Protocollo(String Buffer)
{
  char ChrBuffer = ' ';
  String ingressoSTR = "";
  int ingressoINT = "";
  char stato = ' ';
  String risposta;
  int letturaAnalog;
  String letturaAnalogSTR;
  float letturaAnalogFloat;
  int i;
  if ((Buffer.charAt(0)=='*') && (Buffer.charAt(1)=='*')) //Protocollo accettato se il primo carattere è '*' e il secondo '*'
  {
    if ((Buffer.charAt(2)=='D')||(Buffer.charAt(2)=='A')) 
    {
      if (Buffer.charAt(2)=='D')
      {
        switch (Buffer.charAt(3))
        {
          case 'I':
            if (Buffer.length()==7)
            {
              if (Buffer.charAt(4)=='X') //Richiede lo stato di tutti gli ingressi
              {
                stato = Buffer.charAt(5);
                if (stato=='?') 
                {
                  for (i=1; i<=8; i++)
                  {
                    ingressoSTR = i;
                    ingressoINT = DI[ingressoSTR.toInt()-1];                      
                    if (digitalRead(ingressoINT)==0) stato = 'H';
                    else stato = 'L';            
                    risposta = "#DI" + ingressoSTR + stato + "#"; 
                    Serial.println(risposta);
                    delay(100);
                    stato='?';  
                  }
                }
                else Serial.println("ERROR");                 
              }
              else       //Richiede lo stato dell'ingresso singolo
              {              
                ingressoSTR = (char)Buffer.charAt(4); 
                ingressoINT = DI[ingressoSTR.toInt()-1];
                stato = Buffer.charAt(5);    
                if ((stato=='?')&&(ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  if (digitalRead(ingressoINT)==0) stato = 'H';
                  else stato = 'L'; 
                  risposta = "#DI" + ingressoSTR + stato + "#"; 
                  Serial.println(risposta);
                  stato='?';               
                }           
                else Serial.println("ERROR");          
              }  
            }             
            break;
            
          case 'O': //Uscite digitali
            if (Buffer.length()==7)
            {
              if (Buffer.charAt(4)=='X') //Commuta o richiede lo stato di tutte le uscite in contemporanea
              {
                stato = Buffer.charAt(5);
                if ((stato=='H')||(stato=='L')||(stato=='?'))
                {
                  for (i=1; i<=8; i++)
                  {                  
                    ingressoSTR = String(i);
                    ingressoINT = DO[ingressoSTR.toInt()-1];   
                    if (stato=='H') digitalWrite(ingressoINT,HIGH);
                    if (stato=='L') digitalWrite(ingressoINT,LOW);  
                    if (stato=='?') 
                    {
                      if (digitalRead(ingressoINT)==0) stato = 'L';
                      else stato = 'H';
                    }              
                    risposta = "#DO" + ingressoSTR + stato + "#"; 
                    Serial.println(risposta);
                    delay(100);
                  }  
                }
                else Serial.println("ERROR");  
              }
              else      //Commuta o richiede lo stato di una singola uscita
              {              
                ingressoSTR = (char)Buffer.charAt(4);  
                ingressoINT = DO[ingressoSTR.toInt()-1];
                if ((ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  stato = Buffer.charAt(5);  
                  if ((stato=='H')||(stato=='L')||(stato=='?'))
                  {
                    if (stato=='H') digitalWrite(ingressoINT,HIGH);
                    if (stato=='L') digitalWrite(ingressoINT,LOW);  
                    if (stato=='?') 
                    {
                      if (digitalRead(ingressoINT)==0) stato = 'L';
                      else stato = 'H';
                    }            
                    risposta = "#DO" + ingressoSTR + stato + "#"; 
                    Serial.println(risposta);
                  }
                  else Serial.println("ERROR"); 
                }
                else Serial.println("ERROR"); 
              }  
            }             
            break;
            
          default:
            Serial.println("ERROR");
            break;
        } 
      }   
      if (Buffer.charAt(2)=='A')
      {
        switch (Buffer.charAt(3))
        {
          case 'I':   //Richiesta stato ingressi analogici
            if (Buffer.length()==7)
            {
              if (Buffer.charAt(4)=='X') //Richiede lo stato di tutti gli ingressi
              {
                stato = Buffer.charAt(5);
                for (i=1; i<=8; i++)
                {
                  ingressoSTR = (String)i;     
                  ingressoINT = AI[ingressoSTR.toInt() - 1];                 
                  if (stato=='?') 
                  {                  
                    letturaAnalog=AIN_Read(ingressoINT);
                    //letturaAnalog = analogRead(ingressoINT);
                    if ((letturaAnalog>=0) && (letturaAnalog<10)) letturaAnalogSTR = "000" + (String)letturaAnalog;
                    if ((letturaAnalog>=10) && (letturaAnalog<100)) letturaAnalogSTR = "00" + (String)letturaAnalog;
                    if ((letturaAnalog>=100) && (letturaAnalog<1000)) letturaAnalogSTR = "0" + (String)letturaAnalog;     
                    if (letturaAnalog>=1000) letturaAnalogSTR = (String)letturaAnalog;                          
                  }
                  risposta = "#AI" + ingressoSTR + letturaAnalogSTR + "#";               
                  Serial.println(risposta);
                  delay(100);
                  stato='?';
                }  
              }
              else      //Richiede lo stato dell'ingresso singolo
              {
                ingressoSTR = (char)Buffer.charAt(4); 
                ingressoINT = AI[ingressoSTR.toInt() - 1];
                if ((ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  stato = Buffer.charAt(5);        
                  if (stato=='?') 
                  {                
                    letturaAnalog=AIN_Read(ingressoINT);
                    //letturaAnalog = analogRead(ingressoINT);
                    if ((letturaAnalog>=0) && (letturaAnalog<10)) letturaAnalogSTR = "000" + (String)letturaAnalog;
                    if ((letturaAnalog>=10) && (letturaAnalog<100)) letturaAnalogSTR = "00" + (String)letturaAnalog;
                    if ((letturaAnalog>=100) && (letturaAnalog<1000)) letturaAnalogSTR = "0" + (String)letturaAnalog;              
                    if (letturaAnalog>=1000) letturaAnalogSTR = (String)letturaAnalog;  
                    risposta = "#AI" + ingressoSTR + letturaAnalogSTR + "#";              
                    Serial.println(risposta);
                    stato='?';
                  }
                  else Serial.println("ERROR");
                }
                else Serial.println("ERROR");
              }   
            }            
            break;
  
          case 'V':   //Richiesta stato ingressi analogici
            
            if (Buffer.length()==7)
            {
              if (Buffer.charAt(4)=='X') //Richiede lo stato di tutti gli ingressi
              {
                stato = Buffer.charAt(5);
                if (stato=='?')
                {
                  for (i=1; i<=8; i++)
                  {
                    ingressoSTR = (String)i;     
                    ingressoINT = AI[ingressoSTR.toInt() - 1];                     
                    letturaAnalogFloat=AIN_ReadVoltage(ingressoINT);
                    letturaAnalog=letturaAnalogFloat;
                    if (letturaAnalog=letturaAnalogFloat<10) letturaAnalogSTR = "0";
                    letturaAnalogSTR = letturaAnalogSTR + (String)letturaAnalogFloat;    
                    risposta = "#AV" + ingressoSTR + letturaAnalogSTR + "#";              
                    Serial.println(risposta);
                    delay(100);
                    stato='?';  
                  }                  
                }  
                else Serial.println("ERROR");
              }
              else      //Richiede lo stato dell'ingresso singolo
              {
                ingressoSTR = (char)Buffer.charAt(4); 
                ingressoINT = AI[ingressoSTR.toInt() - 1];
                if ((ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  stato = Buffer.charAt(5);           
                  if (stato=='?') 
                  {
                    letturaAnalogFloat=AIN_ReadVoltage(ingressoINT);
                    letturaAnalog=letturaAnalogFloat;
                    if (letturaAnalog=letturaAnalogFloat<10) letturaAnalogSTR = "0";
                    letturaAnalogSTR = letturaAnalogSTR + (String)letturaAnalogFloat;            
                    risposta = "#AV" + ingressoSTR + letturaAnalogSTR + "#";              
                    Serial.println(risposta);
                    stato='?';
                  }
                  else Serial.println("ERROR");
                }
                else Serial.println("ERROR");
              }   
            } 
            if (Buffer.length()==11)
            {  
              if (Buffer.charAt(4)=='X') //Imposta la singola uscita mediante tensione
              {
                stato = Buffer.charAt(5);
                for (i=1; i<=8; i++)
                {
                  ingressoSTR = (String)i;     
                  ingressoINT = ingressoSTR.toInt(); 
                  letturaAnalogSTR=(String)Buffer.charAt(5) + (String)Buffer.charAt(6) + (String)Buffer.charAt(7) + (String)Buffer.charAt(8) + (String)Buffer.charAt(9);
                  letturaAnalogFloat = letturaAnalogSTR.toFloat();                
                  letturaAnalog=AV_ConvertVoltage(letturaAnalogFloat);
                  dACWrite(AO[ingressoINT-1],letturaAnalog);
                  Serial.println(letturaAnalog);
                  
                  risposta = "#AV" + ingressoSTR + letturaAnalogSTR + "#";              
                  Serial.println(risposta);
                  delay(100);
                  stato='?';
                }  
              }
              else      //Imposta la singola uscita mediante valore 0-255
              {
                ingressoSTR = (char)Buffer.charAt(4); 
                ingressoINT = ingressoSTR.toInt();
                if ((ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  letturaAnalogSTR=(String)Buffer.charAt(5) + (String)Buffer.charAt(6) + (String)Buffer.charAt(7) + (String)Buffer.charAt(8) + (String)Buffer.charAt(9);
                  letturaAnalogFloat = letturaAnalogSTR.toFloat();                
                  letturaAnalog=AV_ConvertVoltage(letturaAnalogFloat);
                  dACWrite(AO[ingressoINT-1],letturaAnalog);
                    
                  risposta = "#AV" + ingressoSTR + letturaAnalogSTR + "#";              
                  Serial.println(risposta);
                  stato='?';
                }
                else Serial.println("ERROR");
              }   
            }              
            break;
            
          case 'O':
            if (Buffer.length()==9)
            {
              if (Buffer.charAt(4)=='X') //Imposta lo stato di tutte le uscite DAC
              {
                letturaAnalogSTR = (char)Buffer.charAt(5);
                letturaAnalogSTR += (char)Buffer.charAt(6);
                letturaAnalogSTR += (char)Buffer.charAt(7);
                letturaAnalog = letturaAnalogSTR.toInt();
                for (i=0; i<8; i++)
                { 
                  ingressoSTR = "0" + (String)i;                
                  dACWrite(AO[i],letturaAnalog);
                  risposta = "#AO" + ingressoSTR + letturaAnalogSTR + "#";
                  Serial.println(risposta);
                }  
              }
              else      //Commuta o richiede lo stato di una singola uscita
              {
                ingressoSTR = (char)Buffer.charAt(4); 
                ingressoINT = ingressoSTR.toInt();               
                if ((ingressoSTR.toInt()>=1)&&(ingressoSTR.toInt()<=8))
                {
                  letturaAnalogSTR = (char)Buffer.charAt(5);
                  letturaAnalogSTR += (char)Buffer.charAt(6);
                  letturaAnalogSTR += (char)Buffer.charAt(7);
                  letturaAnalog = letturaAnalogSTR.toInt();
                  if ((letturaAnalog>=0)&&(letturaAnalog<=255))
                  {
                    dACWrite(AO[ingressoINT-1],letturaAnalog);
                    risposta = "#AO" + ingressoSTR + letturaAnalogSTR + "#";
                    Serial.println(risposta);
                  }
                  else Serial.println("ERROR");
                }
                else Serial.println("ERROR");
              }   
            }            
            break;
  
          default:
            Serial.println("ERROR");
            break;
        } 
      }   
    } 
    else Serial.println("ERROR");
  }
  else Serial.println("ERROR");
}


//******************************************************* Z E R O D A C S *******************************************************
//Imposta a valore ZERO tutte le porte DAC
void zeroDACs()
{
  for (int i=0;i< dACh+1; i+=2)
  {
    dACWrite(i,0);
  }
}



//******************************************************* D A C W R I T E *******************************************************
//Imposta la porta desiderata al valore DAC scelto
void dACWrite(int Canale, int Valore) 
{
  // take the SS pin low to select the chip:
  digitalWrite(LOADD,HIGH);
  //  send in the address and value via SPI:
  SPI.transfer(Canale);
  SPI.transfer(Valore);
  // take the SS pin high to de-select the chip:
  digitalWrite(LOADD,LOW);
}

//********************************* D O U T _ H i g h L o w *********************************
//Imposta alto (1) o basso (0) un pin Digitale a propria scelta
void DOUT_HighLow(int PIN, int Val)
{
  digitalWrite(PIN, Val);
  return;
}


//********************************* D I N _ H i g h L o w *********************************
//Restituisce lo stato del pin digitale in ingresso > alto (1) o basso (0)
int DIN_HighLow(int PIN)
{
  int stato = 0;
  stato=digitalRead(PIN);
  return stato;
}



//********************************* A I N _ R e a d *********************************
//Restituisce il valore analogico 0 - 1024 relativo all'ingresso analogico (ADC)
int AIN_Read(int PIN)
{
  return analogRead(PIN);
}

//********************************* A I N _ R e a d V o l t a g e *********************************
//Restituisce il valore in tensione 0V - 10V relativo all'ingresso analogico (ADC)
//Impostare la variabile AIN_Vmax per stabilire l'ingresso in tensione massimo
float AIN_ReadVoltage(int PIN)
{
  int valore_letto = 0;
  float tensione = 0;
  
  valore_letto = analogRead(PIN);
  tensione = AIN_Vmax * 100;
  tensione = tensione / 1024;    
  tensione = tensione * valore_letto;
  tensione = tensione / 100;
  
  return tensione;
}

//********************************* A V _ C o n v e r t V o l t a g e *********************************
//Restituisce il valore intero da 0 a 255 riguardante la tensione float
int AV_ConvertVoltage(float Voltage)
{
  float tensione = 0;
  int valore = 0;  
  Voltage = Voltage * 100;
  tensione = AIN_Vmax * 100;
  tensione = tensione / 255;  
  tensione = Voltage / tensione;
  valore = tensione;
  return valore;
}
